# vitis_git

Trying to make Vitis more git-friendly.

## Use this repository as template

When you use this repository as template, in the new created repository you can delete this file and rename `README_PROJECT_TEMPLATE.md` to `README.md`.

### Requirements

- Tested on Vitis 2020.2

### How it works

Vitis is a little bit less pain in the ass than Vivado to version control decently, so this repository provide:

- A good to start with `.gitignore` file.

- Git-hook-scripts to eliminate absolute paths in project files.

### Workflow

#### Create new project

1. Use this repository as template and take the `Git Content`.

2. Clone the new created repository - This folder will be the workspace folder.

3. Execute the following command in the workspace folder:

    - `git config --local core.hooksPath .githooks` - set path to git-hooks for this repository.

4. Copy the hardware specification file (.xsa) into the workspace folder.

5. Open Vitis and select the cloned folder as workspace - `vitis -workspace .`.

6. Create a new platform project called `hw_platform` and choose the copied hardware specification file.

7. Build the platform project.

8. Create a new application project via `File -> New -> Application Project...`, choose the platform created befor and name the application project as you want.

9. Execute the following commands in the workspace folder:

    - `git add .` - add all relevant files to the repository - Files that are not relevant are ignored by the `.gitignore` file.

    - `git commit -m 'create project'` - create project commit.

#### Clone existing project

1. After cloning the repository execute the following commands in the cloned folder:

    - `git config --local core.hooksPath .githooks` - set path to git-hooks for this repository.
    
    - `git checkout BRANCH` - checkout the BRANCH you want to work with (e.g. `master`) which create local project files (because the hook script will be executed now ; this could take a while).

2. Open Vitis and select the cloned folder as workspace.

3. Click on `Inport Project`, choose `Import projects from Git` and click `Next >`.

4. Choose `Existing local repository` and click `Next >`.

5. Choose the cloned / workspace folder (should be the only entry) and click `Next >`.

6. Choose `Import existing Eclipse projects` and click `Next >`.

7. Leave everything unchanged and click `Finish`.
